---
title: Programming in C
subtitle: Commandline Arguments
layout: layouts/presentation.njk
---

<section>
  <section>
    <h2>Purpose of Commandline Arguments</h2>
    <ul>
      <li>Allow the user to pass information to a program upon startup
        <ul>
          <li>Which <strong>input files</strong> should be processed<br />
            <code>gcc infile.c</code>
          </li>
          <li><strong>Options</strong> can be defined<br />
            <code>ls -l -a -h</code>
          </li>
          <li>Possible <strong>subcommands</strong><br />
            <code>apt install programname</code>
          </li>
        </ul>
      </li>
    </ul>
  </section>
  <section>
    <h2>Issues</h2>
    <ul>
      <li>String parsing is tedious</li>
      <li>ISO C's <code>getopt</code> (<code>unistd.h</code>) has limited
        features (eg. no long options)</li>
      <li>Many libraries offer differing feature sets</li>
      <li>Argument parsing libraries are usually not trivial to use</li>
    </ul>
  </section>
</section>

<section>
  <h2>Foundation of Argument Passing</h2>
  <section>
    <p>In C, arguments have to be passed to <code>main(.)</code></p>
    <dl>
      <dt><code>argc</code></dt>
      <dd>argument count</dd>
      <dt><code>argv</code></dt>
      <dd>argument vector</dd>
    </dl>
{% highlight "c 0" %}
int main(int argc, char** argv) {
  /* work with arguments */
  return 0;
}
{% endhighlight %}
  </section>

  <section>
    <h3>Example: Echo Arguments Without Using a Library</h3>
{% highlight "c 2-4" %}
{% include "source/c/cli/echo.c" %}
{% endhighlight %}
{% download "/data/c/cli/echo.c" %}
  </section>

  <section>
    <h3>Example: Show a Simple Help Message</h3>
{% highlight "c 5-7" %}
{% include "source/c/cli/help.c" %}
{% endhighlight %}
{% download "/data/c/cli/help.c" %}
  </section>
</section>
{#
#}

<section>
  <h2>POSIX Standard <code>getopt</code></h2>
  <section>
    <dl>
      <dt>+</dt>
      <dd>standardized</dd>
      <dd>avaiable everywhere</dd>
      <dt>-</dt>
      <dd>no support for long options</dd>
      <dd>lack of support for subcommands etc.</dd>
    </dl>
  </section>

  <section>
{% highlight "c 1,7" %}
{% include "source/c/cli/posix_getopt.c" %}
{% endhighlight %}
{% download "/data/c/cli/posix_getopt.c" %}
  </section>
</section>

<section>
  <h2>GNU <code>getopt_long</code></h2>
{% highlight "c 2,8" %}
{% include "source/c/cli/gnu_getopt.c" %}
{% endhighlight %}
{% download "/data/c/cli/gnu_getopt.c" %}
</section>

<section>
  <h2>Comprehensive Example(s)</h2>
  <p>Just look at the source code of your favorite commanline program...</p>
  <p><code>apt source $PACKAGE</code></p>
  <p class="fragment">One possible example (using GNU getopt):
    <a href="https://github.com/senarclens/cvrptwms/blob/master/cli.c">cvrptwms</a></p>
</section>

<section>
  <h2>Other Libraries</h2>
  <p>There are many libraries for argument parsing...</p>
  <p class="fragment">... select the one that suits your needs</p>
  <div class="fragment">
  <dl>
    <dt>argparse</dt>
    <dd><a href="https://github.com/cofyc/argparse">https://github.com/cofyc/argparse</a></dd>
    <dd>MIT License</dd>
  </dl>
  </div>
</section>

<section>
  <section>
  <h2>Exercise</h2>
  <p>Write a C program that takes the following arguments</p>
  <dl>
    <dt><code>-h, --help</code></dt>
    <dt><code>-a, --author</code></dt>
    <dd>display your name and email address</dd>
    <dt><code>--color {red,green,blue}</code></dt>
    <dd>display a message in the given color</dd>
  </dl>
  </section>

</section>

{% include 'slides/closing.njk' %}
